%define oname   webrick

Name:       ruby-%{oname}
Version:    1.7.0
Release:    %mkrel 3
Summary:    HTTP server toolkit
License:    Ruby and BSD-2-Clause
Group:      Development/Ruby
URL:        https://github.com/ruby/%{oname}
Source0:    https://rubygems.org/gems/%{oname}-%{version}.gem
Patch0:     f5faca9222541591e1a7c3c97552ebb0c92733c7.patch
BuildRequires: rubygems
BuildRequires: rubygem(test-unit)
BuildArch:  noarch

%description
WEBrick is an HTTP server toolkit that can be configured as an HTTPS server, a
proxy server, and a virtual-host server.

%files
%{gem_instdir}
%{gem_spec}

#-------------------------------------------------------------------------------
%package        doc
Summary:    Documentation for %{name}
Group:      Development/Ruby
BuildArch:	noarch
Requires:   %{name} = %{version}-%{release}

%description    doc
Documents, Rdoc & RI documentation for %{name}.

%files          doc
%doc %{gem_docdir}

#-------------------------------------------------------------------------------

%prep
%gem_setup
%autopatch -p1

%build
%gem_build

%install
%gem_install

%check
# Test for Patch0
ruby -Ilib -rwebrick -rstringio <<EOF
req = WEBrick::HTTPRequest.new(WEBrick::Config::HTTP)
req.parse(StringIO.new("POST /user HTTP/1.1\r\nContent-Length: 28\r\nTransfer-Encoding: chunked\r\n\r\n0\r\n\r\nGET /admin HTTP/1.1\r\n\r\n"))
begin
  req.body
rescue WEBrick::HTTPStatus::BadRequest
  puts "BadRequest raised as expected"
  exit 0
end
puts "BadRequest was not raised"
exit 1
EOF


%changelog
* Sun Oct 13 2024 pterjan <pterjan> 1.7.0-3.mga9
+ Revision: 2106221
- Add upstream patch preventing request smuggling

* Fri Jul 29 2022 bcornec <bcornec> 1.7.0-2.mga9
+ Revision: 1872957
- Fix typo
- use a macro for oname in URL

* Fri May 27 2022 pterjan <pterjan> 1.7.0-1.mga9
+ Revision: 1860498
- imported package ruby-webrick

